%Script for running heat equation on noisy signal
%Author: Jeff Calder, 2016

N = 1000; %Number of grid points
T = 1000;
k = 10; %Display new graph every k iterations
h = 1/(N-1); %Grid spacing
dt = h^2/3; %Time step for stability

%Initial condition
x = 0:1/(N-1):1;
u = sin(17*x) + 1 + rand(size(x)); 
y_min = 0; %Plot axes
y_max = 3;

plot(x,u);
ylim([y_min y_max]);
pause

%Main loop for solving PDE
for i=1:T
   u = u + dt*(u([2:end,end-1]) - 2*u  + u([2,1:(end-1)]))/h^2;

   if mod(i,k)==0
      plot(x,u);
      ylim([y_min y_max]);
      drawnow
      pause
   end
end

plot(x,u);
ylim([y_min y_max]);



