%Run the Perona-Malik equation for T iterations with parameter k
%Author: Jeff Calder, 2016

function u = PeronaMalik(u,k,T)
%Perona Malik anisotropic diffusion PDE

    for i=1:T
       i;
       GE = u([2:end,end-1],:,:) - u;
       GW = u([2,1:end-1],:,:) - u;
       GS = u(:,[2:end,end-1],:) - u;
       GN = u(:,[2,1:end-1],:) - u;
       
       u = u + 0.25*(GN./(1 + GN.^2/k^2) + GE./(1 + GE.^2/k^2) + GS./(1 + GS.^2/k^2) + GW./(1 + GW.^2/k^2));
    end


end

